# coding: utf-8

"""
    Coinbase Developer Platform APIs

    The Coinbase Developer Platform APIs - leading the world's transition onchain.

    The version of the OpenAPI document: 2.0.0
    Contact: cdp@coinbase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from cdp.openapi_client.models.evm_typed_address_condition import EvmTypedAddressCondition
from cdp.openapi_client.models.evm_typed_numerical_condition import EvmTypedNumericalCondition
from cdp.openapi_client.models.evm_typed_string_condition import EvmTypedStringCondition
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

SIGNEVMTYPEDDATAFIELDCRITERIONCONDITIONSINNER_ONE_OF_SCHEMAS = ["EvmTypedAddressCondition", "EvmTypedNumericalCondition", "EvmTypedStringCondition"]

class SignEvmTypedDataFieldCriterionConditionsInner(BaseModel):
    """
    SignEvmTypedDataFieldCriterionConditionsInner
    """
    # data type: EvmTypedAddressCondition
    oneof_schema_1_validator: Optional[EvmTypedAddressCondition] = None
    # data type: EvmTypedNumericalCondition
    oneof_schema_2_validator: Optional[EvmTypedNumericalCondition] = None
    # data type: EvmTypedStringCondition
    oneof_schema_3_validator: Optional[EvmTypedStringCondition] = None
    actual_instance: Optional[Union[EvmTypedAddressCondition, EvmTypedNumericalCondition, EvmTypedStringCondition]] = None
    one_of_schemas: Set[str] = { "EvmTypedAddressCondition", "EvmTypedNumericalCondition", "EvmTypedStringCondition" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = SignEvmTypedDataFieldCriterionConditionsInner.model_construct()
        error_messages = []
        match = 0
        # validate data type: EvmTypedAddressCondition
        if not isinstance(v, EvmTypedAddressCondition):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EvmTypedAddressCondition`")
        else:
            match += 1
        # validate data type: EvmTypedNumericalCondition
        if not isinstance(v, EvmTypedNumericalCondition):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EvmTypedNumericalCondition`")
        else:
            match += 1
        # validate data type: EvmTypedStringCondition
        if not isinstance(v, EvmTypedStringCondition):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EvmTypedStringCondition`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in SignEvmTypedDataFieldCriterionConditionsInner with oneOf schemas: EvmTypedAddressCondition, EvmTypedNumericalCondition, EvmTypedStringCondition. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in SignEvmTypedDataFieldCriterionConditionsInner with oneOf schemas: EvmTypedAddressCondition, EvmTypedNumericalCondition, EvmTypedStringCondition. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into EvmTypedAddressCondition
        try:
            instance.actual_instance = EvmTypedAddressCondition.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into EvmTypedNumericalCondition
        try:
            instance.actual_instance = EvmTypedNumericalCondition.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into EvmTypedStringCondition
        try:
            instance.actual_instance = EvmTypedStringCondition.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into SignEvmTypedDataFieldCriterionConditionsInner with oneOf schemas: EvmTypedAddressCondition, EvmTypedNumericalCondition, EvmTypedStringCondition. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into SignEvmTypedDataFieldCriterionConditionsInner with oneOf schemas: EvmTypedAddressCondition, EvmTypedNumericalCondition, EvmTypedStringCondition. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], EvmTypedAddressCondition, EvmTypedNumericalCondition, EvmTypedStringCondition]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


