# coding: utf-8

"""
    Coinbase Developer Platform APIs

    The Coinbase Developer Platform APIs - leading the world's transition onchain.

    The version of the OpenAPI document: 2.0.0
    Contact: cdp@coinbase.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from cdp.openapi_client.models.sign_evm_typed_data_field_criterion_types_types_value_inner import SignEvmTypedDataFieldCriterionTypesTypesValueInner
from typing import Optional, Set
from typing_extensions import Self

class SignEvmTypedDataFieldCriterionTypes(BaseModel):
    """
    An object containing EIP-712 type definitions, as well as a primary type for the root message object.
    """ # noqa: E501
    types: Dict[str, List[SignEvmTypedDataFieldCriterionTypesTypesValueInner]] = Field(description="EIP-712 compliant map of model names to model definitions.")
    primary_type: StrictStr = Field(description="The name of the root EIP-712 type. This value must be included in the `types` object.", alias="primaryType")
    __properties: ClassVar[List[str]] = ["types", "primaryType"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SignEvmTypedDataFieldCriterionTypes from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each value in types (dict of array)
        _field_dict_of_array = {}
        if self.types:
            for _key_types in self.types:
                if self.types[_key_types] is not None:
                    _field_dict_of_array[_key_types] = [
                        _item.to_dict() for _item in self.types[_key_types]
                    ]
            _dict['types'] = _field_dict_of_array
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SignEvmTypedDataFieldCriterionTypes from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "types": dict(
                (_k,
                        [SignEvmTypedDataFieldCriterionTypesTypesValueInner.from_dict(_item) for _item in _v]
                        if _v is not None
                        else None
                )
                for _k, _v in obj.get("types", {}).items()
            ),
            "primaryType": obj.get("primaryType")
        })
        return _obj


